<template>
  <div class="view-bar">
    <input-text-field
      class="input"
      type="text"
      :icon="icons.faSearch"
      v-model="query"
      v-on:update:modelValue="onSearch"
    />
    <button class="button" v-on:click="$emit('export-csv')">
      <font-awesome-icon :icon="icons.faFileCsv" />
    </button>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import InputTextField from "@/components/input/InputTextField.vue";

import { faSearch, faFileCsv } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";

@Options({
  components: {
    InputTextField,
    FontAwesomeIcon,
  },
  emits: ["export-csv", "model-search"],
})
export default class ViewSearch extends Vue {
  public query = "";

  public onSearch(): void {
    this.$emit("model-search", { query: this.query, field: "" });
  }

  public icons = {
    faSearch,
    faFileCsv,
  };
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.view-bar {
  text-align: center;
  background: $dark_blue;
  background: linear-gradient(
    180deg,
    $dark_blue 0%,
    $dark_blue 50%,
    rgba(255, 255, 255, 1) 50%,
    rgba(255, 255, 255, 1) 100%
  );
  font-size: 20px;
  font-weight: bold;

  display: grid;
  grid-template-columns:
    1fr calc(min(100% - 2 *#{$standard_margin}, #{$max_list_width}) - 50px)
    40px 1fr;
  grid-template-areas: ". field button .";
  grid-gap: 10px;

  position: relative;
  width: 100%;

  .input {
    grid-area: field;
    padding: 0px;
  }

  .button {
    grid-area: button;
    font-size: 20px;
    color: $dark_blue;
    background-color: white;

    border: none;
    cursor: pointer;

    box-shadow: 0 0 3px 0 $shadow_grey;
  }
}
</style>
